<?php
/**
 * Created by PhpStorm.
 * User: gustavolima
 * Date: 14/09/2015
 * Time: 15:25
 */

namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DataSource\Manager;
use Teknisa\CRM\Service\crm00004000IndicadorLeadService;


class crm00004000IndicadorLeadController extends TeknisaCrud {
    protected $Lead;
    protected $dataSourceName = 'crm_candidato_prospect';

    public function __construct($crudService, $parameterBag, crm00004000IndicadorLeadService $Lead) {
        parent::__construct($crudService, $parameterBag);
        date_default_timezone_set("America/Sao_Paulo");
        $this->Lead = $Lead;
    }

    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $filterData = $request->getFilterCriteria()->getConditions();
        try {
            $result = $this->Lead->getRowsByFilter($filterData);

            $response->addDataSet(new DataSet('crm_candidato_prospect', $result));
        } catch (\Exception $e) {
            $response->addMessage(new Message($e->getMessage()));
        }
    }
}