<?php
/**
 * Created by PhpStorm.
 * User: gustavolima
 * Date: 14/09/2015
 * Time: 14:59
 */

namespace Teknisa\CRM\Service;
use Doctrine\ORM\EntityManager;


class crm00004000IndicadorLeadService {

    /** @var  EntityManager */
    protected $entityManager;
    /** @var  Environment */
    protected $environment;

    public function __construct($entityManager, $environment) {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
    }

    public function getRowsByFilter(array $filterValues)
    {
        $where = "  AND";
        foreach($filterValues as $valuesToFilter)
        {
            if($valuesToFilter['operator'] == 'BETWEEN' && !(empty($valuesToFilter['value'][0]) && empty($valuesToFilter['value'][1])))
            {
                $where .= " ";


                if((!empty($valuesToFilter['value'][0])&&($valuesToFilter['value'][0]!='Invalid date')) && (!empty($valuesToFilter['value'][1])&&($valuesToFilter['value'][1]!='Invalid date')))
                {
                    $aux = explode(' ',$valuesToFilter['value'][0]);
                    $auxF = explode(' ',$valuesToFilter['value'][1]);
                    $dtini = explode('/',$aux[0]);
                    $dtfinal = explode('/',$auxF[0]);
                    $where .= " TO_CHAR(PROSP.".$valuesToFilter['columnName'].",'YYYY/MM') BETWEEN '".$dtini[2]."/".$dtini[1]."' AND '".$dtfinal[2]."/".$dtfinal[1]."' AND ";
                }
                elseif((!empty($valuesToFilter['value'][0])&&($valuesToFilter['value'][0]!='Invalid date')) && (empty($valuesToFilter['value'][1])||($valuesToFilter['value'][1]=='Invalid date')))
                {
                    $aux = explode(' ',$valuesToFilter['value'][0]);
                    $dtini = explode('/',$aux[0]);
                    $where .= " TO_CHAR(PROSP.".$valuesToFilter['columnName'].",'YYYY/MM') >= '".$dtini[0]."/".$dtini[1]."' AND ";
                }
                elseif((empty($valuesToFilter['value'][0])||($valuesToFilter['value'][0]=='Invalid date')) && (!empty($valuesToFilter['value'][1])&&($valuesToFilter['value'][1]!='Invalid date')))
                {
                    $auxF = explode(' ',$valuesToFilter['value'][1]);
                    $dtfinal = explode('/',$auxF[0]);
                    $where .= " TO_CHAR(PROSP.".$valuesToFilter['columnName'].",'YYYY/MM') <= '".$dtfinal[0]."/".$dtfinal[1]."' AND ";
                }
            }
            else
            {
                if($valuesToFilter['operator'] == '=')
                {
                    $where .= " PROSP.".$valuesToFilter['columnName']." = '".$valuesToFilter['value']."' AND ";
                }
                elseif($valuesToFilter['operator'] == 'IN')
                {
                    if($valuesToFilter['columnName']=='CDOPERINCLUSAO')
                    {
                        $where .= " PROSP.".$valuesToFilter['columnName']." IN ('";
                    }
                    else
                    {
                        $where .= " ".$valuesToFilter['columnName']." IN ('";
                    }
                    foreach($valuesToFilter['value'] as $valor)
                    {
                        $where .= $valor."','";
                    }
                    $where = substr($where,0,strlen($where)-2).") AND ";
                }
            }
        }
        $where = substr($where,0,strlen($where)-5);

        $sql = "SELECT COUNT(NRCANDIDATO) AS QTDECAND,
                       TO_CHAR(PROSP.DTINCLUSAO,'YYYY/MM') AS DTORDER,
                       TO_CHAR(PROSP.DTINCLUSAO,'Mon/YYYY') AS DTLABEL
                  FROM CRM_CANDIDATO CAND
                 INNER JOIN PROSPECT PROSP
                       ON CAND.NRPARCNEGOCIO = PROSP.NRPARCNEGOCIO
                       AND CAND.NRORG = PROSP.NRORG
                 WHERE PROSP.IDATIVO = 'S'
                   AND CAND.IDATIVO = 'S'
                         ";
        $sql .= $where;

        $sql .= "
                    GROUP BY TO_CHAR(PROSP.DTINCLUSAO,'YYYY/MM'),TO_CHAR(PROSP.DTINCLUSAO,'Mon/YYYY')
                    ORDER BY TO_CHAR(PROSP.DTINCLUSAO,'YYYY/MM')";

        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute();
        $dataSet = $std->fetchAll();

        return $dataSet;
    }
}