<?php

namespace Teknisa\CRM\Util;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DTO;
use Teknisa\CRM\Service\GeralService;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Teknisa\CRM\Util\ConsultaInscricaoRF;

class ConsultaInscricaoRF {
    
    public static function consultaDadoRF($NrInscricao)
	{

		/*$opc = array('proxy_host'=>"192.168.122.3",
	             'proxy_port'=>8080,
	             'proxy_login'=>"",
	             'proxy_password'=>"");*/
		$client = new \SoapClient('http://www.soawebservices.com.br/webservices/producao/cdc/cdc.asmx?WSDL');

        if (strlen($NrInscricao) == 14)
            $function = 'PessoaJuridicaNFe';
        else
            $function = 'PessoaFisicaSimplificada';
	 
		$arguments = array(array('Credenciais' => array('Email' => 'administrativo@teknisa.com',
	                                             	 	'Senha' => 'K1*#n2'),
	    	                    'Documento'    => $NrInscricao));
		$options = array('location' => 'http://www.soawebservices.com.br/webservices/producao/cdc/cdc.asmx');

        try {
            $result = $client->__soapCall($function, $arguments, $options);
        }catch (\Exception $e)
        {
            return  array("Status" => false, "CONEXAO" => true);
        }

	 	$result = json_encode($result);
	 	$resultadoConsulta = json_decode($result,true);
		return $resultadoConsulta[$function.'Result'];
	}
}