<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DTO;

class crm00031000ConsumoController extends TeknisaCrud {
    protected $dataSourceName = 'crm_classificatarefa';
    protected $primaryKey = 'NRSEQCLASSIFICATAREFA';
    //protected $CDCONTADOR = 'CRMCLASSIFICATAREFA';

    public function save(DTO\Request $request, DTO\Response $response) {
    	foreach($request->getDataSet()->getRows() as $row) {
            if(!array_key_exists('DSDETEFILACONTA', $row)) $row['DSDETEFILACONTA'] = null;
            if(!array_key_exists('NRRELACIONAPARC', $row)) $row['NRRELACIONAPARC'] = null;
            if($row["__is_new"])
            {
                $row['__new_code_pk'] = "CRMCLASSIFICATAREFA";
                $row['__table_pk'] = "NRSEQCLASSIFICATAREFA";
                $row['__cast_number'] = true;
                $row['__new_code_length'] = 20;
            }
        }
    	parent::save($request, $response);
    }
}